#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

#define ABS(x) (((x)<0)?-(x):(x))

#define MAXL	(100)

static char *tobase(int N, int R) {
	int maxD = ABS(R)-1;
	struct {
		int val;
		int Mval, mval;
	} vals[MAXL+1];

	vals[0].val=1; vals[0].mval=0; vals[0].Mval=maxD;
	for(int i=1;i<=MAXL;i++) {
		vals[i].val = R*vals[i-1].val;
		vals[i].mval = vals[i-1].mval + std::min(0, maxD*vals[i-1].val);
		vals[i].Mval = vals[i-1].Mval + std::max(0, maxD*vals[i-1].val);
	}

	static char buf[MAXL+2];
	int dig = MAXL;
}

static int  frombase(char *buf, int R) {
	int base = 1;
	int res = 0;
	char *Z = buf+(strlen(buf)-1);
	while(buf!=Z) {
		res += (*Z - '0')*base;
		base *= R; Z--;
	}
	return res;
}

int main() {
	int B=-3;
	for(int i=0;i<100;i++) {
		char *val = tobase(i,B);
		fprintf(stderr,"%d: <%s> %d\n",i,val,frombase(val,B));
	}
	return 0;
}

