#include <cstdio>
#include <algorithm>
#include <queue>
using namespace std;

#define DUZO		(1<<20)

#define MAXPARC		(4)
#define MAXH		(24)

#define ABS(x)		((x)<0?-(x):(x))

#define POZYCJA		(y,x,p) ( ((y)*MAXH + (x))*(1<<4) + (p) )

static char pole[MAXH*2][MAXH*2];
static int odl[POZYCJA(MAXH,0,0)];

static int H;

//#define poshex(x,y) 

static std::priority_queue<pair<int,int> > Q;

static void RELAX(int pozycja, int val) {
	if(odl[pozycja]>val) {
		Q.push(make_pair(val, pozycja));
	}
}

int main() {
	while(scanf("%d",&H)==1 && H>0) {
		Q.clear();
		char buf[4];
		for(int i=0;i<=(2*H+2);i++) {
			pole[0][i] = 0;
			pole[2*H-1][i] = 0;
		}
		for(int i=0;i<(sizeof(odl)/sizeof(tab[0]));i++)
			odl[i] = DUZO;
		for(int lin=0;lin<=(2*H-2);lin++) {
			int puste = ABS((H-1)-lin)/2;
			int ilepol = 2*H-1 - ABS((H-1)-lin);
			pole[lin+1][puste]=0;
			pole[lin+1][puste+ilepol+1]=0;
			for(int i=0;i<ilepol;i++) {
				int x = puste + 1 + i;
				int y = lin + 1;
				scanf("%s",buf);
				pole[y][x] = buf[0];

				if(buf[0]>='A' && buf[0] <= 'D') {
					RELAX(POZYCJA(y,x,1<<(buf[0]-'A')),-1);
				}
			}
		}
	}
	return 0;
}

